#include <ntddk.h>

#define DBGPRINT 0
#define MAX_IMAGE_NAME_LEN 15

#define PROCMAP_NT_DEVICE_NAME L"\\Device\\PROCMAP"
#define PROCMAP_DOS_DEVICE_NAME L"\\DosDevices\\PROCMAP"

#define PROCMAP_DEVICE_TYPE 32768

enum {
    
    PROCMAP_IOCTL_TERMINATE_PROCESS = 2048,
    PROCMAP_IOCTL_TERMINATE_IMAGE
};

#define IOCTL_PROCMAP_TERMINATE_PROCESS CTL_CODE(PROCMAP_DEVICE_TYPE, PROCMAP_IOCTL_TERMINATE_PROCESS, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_PROCMAP_TERMINATE_IMAGE   CTL_CODE(PROCMAP_DEVICE_TYPE, PROCMAP_IOCTL_TERMINATE_IMAGE, METHOD_BUFFERED, FILE_WRITE_ACCESS)

NTSTATUS DriverEntry(
    IN PDRIVER_OBJECT  DriverObject,
    IN PUNICODE_STRING RegistryPath
);

void PmUnload(
    IN PDRIVER_OBJECT DriverObject
);

void PmCreateNotifyRoutine(
    IN HANDLE  ParentId,
    IN HANDLE  ProcessId,
    IN BOOLEAN  Create
);

NTSYSAPI NTSTATUS NTAPI ZwOpenProcess(
    OUT PHANDLE ProcessHandle,
    IN ACCESS_MASK DesiredAccess,
    IN POBJECT_ATTRIBUTES ObjectAttributes,
    IN PCLIENT_ID ClientId
);

NTSYSAPI NTSTATUS NTAPI ZwTerminateProcess(
    IN HANDLE OPTIONAL,
    IN NTSTATUS ExitStatus
);

void PmMapProcessName(
    char *ImageName
);

ULONG PmGetImageNameOffset(
    void
);

NTSTATUS Pm_MJ_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
);

NTSTATUS Pm_MJ_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
);

NTSTATUS Pm_MJ_DeviceControl(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
);

